chiark / gitweb /
Merge branch 'master' of git.distorted.org.uk:~mdw/publish/public-git/profile
[profile] / bin / mdw-build
1 #! /bin/bash
2 ###
3 ### Build script for Debian packages
4 ###
5 ### (c) 2008 Mark Wooding
6 ###
7
8 ###----- Licensing notice ---------------------------------------------------
9 ###
10 ### This program is free software; you can redistribute it and/or modify
11 ### it under the terms of the GNU General Public License as published by
12 ### the Free Software Foundation; either version 2 of the License, or
13 ### (at your option) any later version.
14 ###
15 ### This program is distributed in the hope that it will be useful,
16 ### but WITHOUT ANY WARRANTY; without even the implied warranty of
17 ### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
18 ### GNU General Public License for more details.
19 ###
20 ### You should have received a copy of the GNU General Public License
21 ### along with this program; if not, write to the Free Software Foundation,
22 ### Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
23
24 ###--------------------------------------------------------------------------
25 ### Conventions for build systems.
26 ###
27 ### This script is designed to work with a variety of `make'-based build
28 ### systems, but there are a number of conventions which must be followed if
29 ### this is going to work properly.
30 ###
31 ###   * There must be a `configure.ac', `configure.in', or `.links' file, or
32 ###     a `.git' directory in the project top-level, so that we can find it.
33 ###
34 ###   * The following `make' variables must be assigned in the top-level
35 ###     Makefile, after `mdw-build' has constructed it.
36 ###
37 ###     distdir         The name of the top-level project directory in the
38 ###                     source distribution, and the base name for
39 ###                     distribution archives; should be of the form
40 ###                     `PROJECT-VERSION'.
41 ###
42 ###     The following `make' targets must be available in the top-level
43 ###     Makefile.
44 ###
45 ###     dist            Write to $(distdir).tar.gz a source distribution of
46 ###                     the package.
47 ###
48 ###     distcheck       As for `dist', but also build and test the project.
49 ###
50 ###  * The source distribution constructed by `make dist' must contain a file
51 ###     $(distdir)/RELEASE containing the release name.  This isn't currently
52 ###     tested, but it might be later.
53
54 set -e
55
56 ###--------------------------------------------------------------------------
57 ### Parse options.
58
59 usage () {
60   cat <<EOF
61 Usage: $0 [-vr] BUILDOPT
62
63 Build options:
64
65   [no]checkout[=REV]
66   [no]release
67   [no]setup[=RUNE]
68   [no]distcheck
69   [no]debian
70   [no]upload
71   [no]clean
72   [no]vpath
73   [no]native
74 EOF
75 }
76
77 ## Parse simple options.
78 verbose=no
79 while getopts "hvr" opt; do
80   case "$opt" in
81     h) usage; exit 0 ;;
82     v) verbose=yes ;;
83     *) exit 1 ;;
84   esac
85 done
86 shift $((OPTIND - 1))
87
88 ## Parse the build options.
89 checkout=yes
90 checkoutrev=HEAD
91 build=test
92 setup=yes
93 setupcmd=mdw-setup
94 distcheck=yes
95 debian=yes
96 upload=yes
97 clean=yes
98 vpath=yes
99 native=yes
100 for opt; do
101   case "$opt" in
102     checkout)   checkout=yes checkoutrev=HEAD ;;
103     checkout=*) checkout=yes checkoutrev=${opt#*=} ;;
104     release)    build=release ;;
105     norelease)  build=test ;;
106     setup)      setup=yes setupcmd=mdw-setup ;;
107     setup=*)    setup=yes setupcmd=${opt#*=} ;;
108
109     distcheck | debian | upload | clean | vpath | native)
110       eval "$opt=yes"
111       ;;
112     nocheckout | nosetup | nodistcheck | nodebian | \
113     noupload | noclean | novpath | nonative)
114       eval "${opt#no}=no"
115       ;;
116     *)
117       usage >&2
118       exit 1
119       ;;
120   esac
121 done
122
123 ## Parse DEB_BUILD_OPTIONS.
124 jobs=1
125 set -- $DEB_BUILD_OPTIONS
126 for opt; do
127   case "$opt" in
128     parallel=*) jobs=${opt#*=} ;;
129   esac
130 done
131
132 makeopts=""
133 case $jobs in 1) ;; *) makeopts="$makeopts -j$jobs" ;; esac
134
135 ###--------------------------------------------------------------------------
136 ### Utility functions.
137
138 exec 3>&2 4>/dev/null 5>&2
139
140 notify () {
141   colour=$1 message=$2
142   echo $message >&4
143   echo "$(tput bold; tput setaf $colour)$message$(tput sgr0; tput op)" >&5
144 }
145
146 fail () {
147   notify 1 "!!! $*"
148   exit 1
149 }
150
151 warn () {
152   case $build in
153     release) fail "$*" ;;
154     *) notify 5 "??? $*" ;;
155   esac
156 }
157
158 info () {
159   notify 6 "--- $*"
160 }
161
162 assign () {
163   info "$1 = $2"
164   eval "$1=$2"
165 }
166
167 runx () {
168   notify 2 "+++ $*"
169   "$@" 2>&3 || fail "$1: exit $?"
170 }
171
172 run () { runx "$@" >&3; }
173
174 yesno () {
175   echo -n "(test $*)" >&4
176   if "$@" >&4 2>&4; then
177     echo "(yes)" >&4
178     echo yes
179   else
180     echo "(no)" >&4
181     echo no
182   fi
183 }
184
185 ###--------------------------------------------------------------------------
186 ### Do the building.
187
188 ## Find the top-level package directory.
189 while [ ! -f configure.ac -a ! -f configure.in -a \
190         ! -f .links -a ! -d .git ]; do
191   case "$(pwd)" in
192     /)
193       fail "couldn't find top-level directory"
194       ;;
195   esac
196   cd ..
197 done
198 assign srcpath $(pwd)
199
200 ## Construct the output directory.
201 assign releasepath $srcpath/dist-$build
202 chmod -R +w $releasepath 2>/dev/null || :
203 rm -rf $releasepath 2>/dev/null || :
204 mkdir $releasepath
205 case $verbose in
206   no)
207     exec 4>$releasepath/mdw-build.log 3>&4 ||
208       fail "Failed to create log."
209     ;;
210 esac
211
212 ## Do we have a Git repository?
213 case "$checkout,$setup,$(yesno [ -d $srcpath/.git ])" in
214   yes,no,*)
215     fail "Inconsistent options: can't check out without setup."
216     ;;
217   yes,yes,no)
218     info "No Git repository found."
219     checkout=no gitver=none
220     ;;
221   yes,yes,yes)
222     cd $srcpath
223     [ "$(git ls-files -m)" = "" ] ||
224       warn "working tree has uncommitted changes"
225     gitver=$(git describe --abbrev=4)
226 esac
227
228 ## Is there Debian build equipment?
229 case "$debian,$(yesno [ -d $srcpath/debian ])" in
230   yes,no)
231     info "No debian directory found."
232     debian=no debver=none
233     ;;
234   no,*)
235     debver=none
236     ;;
237   yes,yes)
238     debver=$(dpkg-parsechangelog | sed -n 's/^Version: //p' | tr \~ -)
239     debsrc=$(dpkg-parsechangelog | sed -n 's/^Source: //p')
240     debname=$(git config user.name) debemail=$(git config user.email)
241     ;;
242 esac
243
244 ## Check the version number.
245 hack_dch_p=no
246 case "$gitver,$debver" in
247   none,* | *,none)
248     ;;
249   *)
250     if [ "$gitver" != "$debver" ]; then
251       warn "Git version $gitver doesn't match Debian version $debver"
252       hack_dch=yes
253     fi
254     ;;
255 esac
256
257 ## Maybe check out a copy of the source.
258 case "$checkout" in
259   yes)
260     cd $releasepath
261     run git clone -sn $srcpath/.git _source
262     assign srcpath $releasepath/_source
263     cd $srcpath
264     run git checkout -b mdw-build $checkoutrev
265     ;;
266 esac
267
268 ## Maybe refresh the build machinery.
269 case "$setup" in
270   yes)
271     run $setupcmd
272     ;;
273 esac
274
275 ## Initialize the build directory.
276 case "$vpath,$(yesno [ -e $srcpath/configure ])" in
277   yes,yes)
278     assign buildpath $releasepath/_build
279     mkdir $buildpath
280     cd $buildpath
281     run $srcpath/configure
282     ;;
283   no,yes)
284     info "VPATH build disabled"
285     assign buildpath $srcpath
286     distcheck=no
287     cd $srcpath
288     run ./configure
289     ;;
290   *,no)
291     info "no configure script"
292     assign buildpath $srcpath
293     cd $srcpath
294     ;;
295 esac
296
297 ## Discover the release name.
298 cat >find-distdir.mk <<'EOF'
299 include Makefile
300 print-distdir:
301         @echo >&3 $(distdir)
302 EOF
303 assign distdir \
304         $({ make -f find-distdir.mk print-distdir >/dev/null 2>&1; } 3>&1)
305
306 ## Get a tarball distribution.
307 case "$distcheck" in
308   yes)
309     run make $makeopts distcheck
310     ;;
311   no)
312     run make $makeopts dist
313     ;;
314 esac
315
316 cd $releasepath
317
318 case $native in
319   yes)
320     if ! tar tf $buildpath/$distdir.tar.gz 2>/dev/null | grep -q RELEASE
321     then
322       fail "missing RELEASE file in distribution"
323     fi
324     ;;
325 esac
326
327 run mv $buildpath/$distdir.tar.gz .
328 case $build in
329   release)
330     run gpg -u$(mdw-conf releasekey) -ab -o$distdir.tar.gz.gpg \
331       $distdir.tar.gz
332     ;;
333 esac
334
335 ## Maybe build the Debian packages.
336 case "$debian" in
337   yes)
338     run tar xvfz $distdir.tar.gz
339     cd $distdir
340     case $hack_dch in
341       yes)
342         dver=$(echo $gitver | sed 's/-/+/; s/-/./g')
343         now=$(date -R)
344         cat - debian/changelog >debian/changelog.new <<EOF
345 $debsrc ($dver) experimental; urgency=low
346
347   * Hacking in process, not intended for release.
348
349  -- $debname <$debemail>  $now
350
351 EOF
352         mv debian/changelog.new debian/changelog
353         ;;
354     esac
355     run dpkg-buildpackage -k$(mdw-conf releasekey)
356     ;;
357 esac
358
359 ## Maybe upload Debian packages.
360 cd $releasepath
361 case "$upload,$build" in
362   yes,test)
363     info "Test build: not uploading."
364     ;;
365   yes,release)
366     run rsync $distdir.tar.gz $distdir.tar.gz.gpg \
367       $(mdw-conf upload-target ftp.distorted.org.uk:~ftp/pub/mdw/)
368     case "$debian" in
369       yes)
370         run dput -f $(mdw-conf dput-target distorted) *.changes
371         ;;
372     esac
373 esac
374
375 ## Tidy up.
376 case "$clean" in
377   yes)
378     rm -rf $releasepath/$distdir
379     rm -rf $releasepath/_source
380     rm -rf $releasepath/_build
381     ;;
382 esac
383
384 ## Done.
385 info "All OK."
386
387 ###----- That's all, folks --------------------------------------------------